<?php
/**
 * WPImporter - Configuration
 * 
 * 
 *
 * @copyright 2018 SCHLIX Web Inc
 *
 * @license GNU GPLv3
 *
 * @package wpimporter
 * @version 1.0
 * @author  SCHLIX Web Inc <info@schlix.com>
 * @link    http://www.schlix.com
 */
if (!defined('SCHLIX_VERSION')) die('No Access');
?>

<schlix-data-editor id="schlix-<?= $this->app_name ?>-admin" class="schlix-data-editor" data-app="<?= $this->app->getApplicationNameOnly() ?>" data-main-app-description="<?= $this->app->getApplicationDescription() . ' ' . ___(': Configuration') ?>"  data-schlix-controller="SCHLIX.CMS.WPImporterAdminController" data-model="<?= $this->getDataModelURL() ?>" data-field-id="id" data-cancel-warning="true">

    <!-- content -->
    <div class="content">
        <?php 
            ///////////////////////////////
            // Display save error, if any
            $this->displayLastConfigSaveResult();
            ///////////////////////////////
        ?>        
        
        <form method="post" action="<?= $this->createFriendlyAdminURL("action=saveconfig") ?>" autocomplete="off" >
            <div class="row">
                <div class="col-md-8">
                    <!-- -->
                </div>
                <div class="col-md-4 text-right" schlix-id="data-editor-toolbar">
                    <button type="submit" class="btn btn-success schlix-command-button" data-schlix-command="save-item" name="btn_save"><i class="fa fa-check"></i> <?= ___('Save'); ?></button>
                    <button type="submit" class="btn btn-danger schlix-command-button" data-schlix-command="cancel-item" name="btn_save"><i class="fa fa-times"></i> <?= ___('Cancel'); ?></button>
                </div>            
            </div>        
             <?= \INPUT::CSRF() ?>

            <!-- begin tabs -->
            <div class="schlixui-tabcontainer">
                <!-- tab navigation -->
                <ul class="schlixui-tabheader">
                    <li  class="selected"><a href="#tab1"><em><?= ___('Application Configuration') ?></em></a></li>                
                    <li><a href="#tab2"><em><?= ___('Permissions') ?></em></a></li>
                </ul>
                <!-- end tab navigation -->
                <!-- tab ocntent -->
                <div class="schlixui-tabcontent">
                    <!-- tab -->
                    <!-- tab -->
                    <div id="tab1">
                        <!--config -->
                        <schlix-config:app_alias class='form-control' config-default-value="<?= strtolower($this->schlix_master_class) ?>" />
                        <schlix-config:app_description class='form-control' />
                        <schlix-config:textbox config-key='str_meta_keywords' label='<?= ___('Meta Keywords') ?>' class='form-control' />
                        <schlix-config:textbox config-key='str_meta_description' label='<?=  ___('Meta Description') ?>' class='form-control' />
                        <!-- end config -->
                        <!-- Example begins -->
                        <schlix-config:textbox config-key='str_example_1' label='<?= ___('Textbox Example') ?>' class='form-control' />
                        <schlix-config:textarea config-key='str_example_2' label="<?= ___('Textarea Example') ?>" class='wysiwyg' />             
                        <schlix-config:textarea config-key='str_example_3' label="<?= ___('Non-WYSIWYG textarea example') ?>" class='form-control'  />             

                        <schlix-config:integerbox config-key='int_integerbox_example' config-default-value="1" min="1" max="200"  label='<?= ___('Integer box example with default value') ?>' class='form-control' />

                        <schlix-config:checkbox config-key='bool_checkbox_example' label='<?= ___('Checkbox Example') ?>' />

                        <schlix-config:dropdownlist class="form-control" config-key="str_option_select" label="<?= ___('Dropdown list example') ?>" >
                            <schlix-config:option value="0"><?= ___('Please select') ?></schlix-config:option>
                            <schlix-config:option value="<?= ___h('opt1') ?>"><?= ___h('Option 1') ?></schlix-config:option>
                            <schlix-config:option value="<?= ___h('opt2') ?>"><?= ___h('Option 2') ?></schlix-config:option>
                            <schlix-config:option value="<?= ___h('opt3') ?>"><?= ___h('Option 3') ?></schlix-config:option>
                        </schlix-config:dropdownlist> 

                        <schlix-config:radiogroup config-key="int_option_radio" label="<?= ('Radio group example') ?>">
                            <schlix-config:option value="1"><?= ___h('Option 1') ?></schlix-config:option>
                            <schlix-config:option value="2"><?= ___h('Option 2') ?></schlix-config:option>
                            <schlix-config:option value="3"><?= ___h('Option 3') ?></schlix-config:option>
                        </schlix-config:radiogroup>

                        <schlix-config:checkboxgroup config-key="int_option_checkbox" label="<?= ('Checkbox group example') ?>">
                            <schlix-config:option value="1"><?= ___h('Option 1') ?></schlix-config:option>
                            <schlix-config:option value="2"><?= ___h('Option 2') ?></schlix-config:option>
                            <schlix-config:option value="3"><?= ___h('Option 3') ?></schlix-config:option>
                        </schlix-config:checkboxgroup>    
                       <!-- Example Ends -->
                    </div>
                    <!-- tab -->
                    <div id="tab2">
                        
                        <schlix-config:permission-usergroups config-key='array_groups_allowed_for_backend_access' label='<?=  ___('Enable backend access for the following user groups') ?>' />

                        <p><?= ___('Administrators will always be allowed to access to the backend, regardless of the settings above. If nothing is specified, all users who already have access to the backend can access this extension.'); ?></p>
                    </div>
                </div>
            </div>
            <br />
        </form>
    </div>
</schlix-data-editor>