<?php
/**
 * 
 *
 * @copyright 2018 SCHLIX Web Inc
 *
 * @license GNU GPLv3
 *
 * @package wpimporter
 * @version 1.0
 * @author  SCHLIX Web Inc <info@schlix.com>
 * @link    http://www.schlix.com
 */
if (!defined('SCHLIX_VERSION'))
    die('No Access');


if (empty($_SESSION['wp_dbhost']))
    $_SESSION['wp_dbhost'] = 'localhost';
?>
<x-ui:schlix-data-explorer-blank id="schlix-<?= $this->app->getApplicationNameOnly() ?>-admin" class="schlix-data-explorer"  data-schlix-controller="SCHLIX.CMS.WPImporterAdminController" data-main-app-description="<?= $this->app->getApplicationDescription() ?>" data-app="<?= $this->app->getApplicationNameOnly() ?>" data-model="<?= $this->getDataModelURL() ?>">
    <!-- {top_menu} -->

                <x-ui:panel type="panel-default">
                    <x-ui:panel-header>
                        <?= ___('Import content from Wordpress') ?>
                    </x-ui:panel-header>
                    <x-ui:panel-body>
                        <p><?= ___('This application will import and OVERWRITE your current SCHLIX CMS content (blog and html apps) from Wordpress') ?></p>
                        <p><?= ___('Please note that this is an unsupported application for educational purpose only') ?></p>
                    <x-ui:csrf />
                    <x-ui:hidden name="db_tested" id='db_tested' value="0" />

                    <!-- body -->
                    <x-ui:row>
                        <x-ui:column sm="8">
                            <x-ui:textbox name="db_host" id="db_host" fonticon="fa fa-server" label="<?= ___('Host') ?>" autocomplete="off" required="required" pattern="^[A-Za-z0-9-_\.]{1,100}$" value="<?= ___h($_SESSION['wp_dbhost']) ?>"    />
                             
                            <!-- field -->
                            <x-ui:textbox name="db_database" id="db_database" fonticon="fa fa-database" label="<?= ___('Database Name') ?>" autocomplete="off" required="required" pattern="^[A-Za-z0-9-_]{1,63}$" value="<?= ___h($_SESSION['wp_dbname']) ?>"   />
                             
                            <!-- field -->
                             <x-ui:textbox name="db_username" id="db_username"  fonticon="far fa-user" label="<?= ___('Username') ?>" autocomplete="off" required="required" pattern="^[A-Za-z0-9- _]{1,63}$" value="<?= ___h($_SESSION['wp_dbusername']) ?>"  />
                             
                             <!-- field -->
                             <x-ui:textbox type="password" name="db_password" id="db_password"  fonticon="fa fa-lock" label="<?= ___('Password') ?>" autocomplete="off" required="required" value="<?= ___h($_SESSION['wp_dbpassword']) ?>" />                         
 
                            <!-- end settings -->
                        </x-ui:column>
                        <x-ui:column sm="4">
                            <!-- button -->
                            <x-ui:link-button-warning id="btn_test_database" label="<?= ___('Test Connection') ?>" fonticon="fas fa-database" />
                            <x-ui:link-button-ok id="btn_perform_import" label="<?= ___('Import Now') ?>" fonticon="fas fa-arrow-right" />
                           
                            <div id="db_test_result"></div>
                            <!-- end button -->
                        </x-ui:column>
                    </x-ui:row>
                    </x-ui:panel-body>
                    <!-- end body -->
                </x-ui:panel>
<!-- End Data Viewer -->
</x-ui:schlix-data-explorer-blank>
