<?php
namespace App;

/**
 * WPImporter - Admin class
 * 
 * 
 *
 * @copyright 2018 SCHLIX Web Inc
 *
 * @license GNU GPLv3
 *
 * @version 1.0
 * @package wpimporter
 * @author  SCHLIX Web Inc <info@schlix.com>
 * @link    http://www.schlix.com
 */
class WPImporter_Admin extends \SCHLIX\cmsAdmin_Basic {

    /**
     *
     * @var \SCHLIX\cmsDatabase 
     */
    protected  $db;
    
    public function __construct() {
        // Data: Item
        $methods = array('standard_main_app' => 'Main Page',);

        parent::__construct('basic', $methods);      
        
        
    }
    
    
    private function ajaxGetDatabaseTestResult()
    {
        //ini_set("display_errors",0);
        $db_host = filter_var(fpost_string('host',255), FILTER_SANITIZE_STRING);
        $db_username =  filter_var(fpost_string('username',128), FILTER_SANITIZE_STRING);
        $db_password = fpost_string('password',64);
        $db_database = filter_var(fpost_string('database',64), FILTER_SANITIZE_STRING);
        
        $_SESSION['wp_dbhost'] = $db_host;
        $_SESSION['wp_dbusername'] = $db_username;
        $_SESSION['wp_dbpassword'] = $db_password;
        $_SESSION['wp_dbname'] = $db_database;
        /*
        if (strtolower($db_database) == SCHLIX_DB_DATABASE)
            return ajax_reply(300,___('You cannot overwrite the database of current site!'));*/
        
        if (empty($db_host))
            return ajax_reply(300,___('Host name cannot be empty'));
        if (empty($db_username))
            return ajax_reply(300,___('Username cannot be empty'));
        if (empty($db_password))
            return ajax_reply(300,___('Password cannot be empty'));
        if (empty($db_database))
            return ajax_reply(300,___('Database name cannot be empty'));        
        $link = @mysqli_connect($db_host, $db_username, $db_password);
        if ($link)
        {
            $sql = 'SHOW DATABASES LIKE '.  sanitize_string($db_database);
            $result = [];
            $last_query_result = mysqli_query($link, $sql);
            while ($row = mysqli_fetch_assoc($last_query_result))
                $result[] = $row;
            mysqli_free_result($last_query_result);
            mysqli_close($link);    
            if (___c($result) > 0)
            {
                $db = array_values($result[0])[0];
                return ajax_reply(200,sprintf(___('Connected successfully to database [%s]'), $db));
            } else
            {
                return ajax_reply(200,'Connected successfully');
            }
        } else
        {
            return ajax_reply(300,'Cannot connect to the database');
        }
    }
    
    public  function getPostMetaByID($id)
    {
        $id = (int) $id;
        $sql = "SELECT * FROM wp_postmeta WHERE  post_id = {$id}";
        return $this->db->getQueryResultArray($sql);        
        
    }
    
    public  function getAllWPCategories()
    {
        $sql="SELECT * From wp_terms wt INNER JOIN wp_term_taxonomy wtt ON wt.term_id=wtt.term_id WHERE wtt.taxonomy='category' ";
        return $this->db->getQueryResultArray($sql);
        
    }

    
    public  function getPostCategories($id)
    {
        $id = (int) $id;
        $sql="SELECT wt.* FROM wp_posts p
 INNER JOIN wp_term_relationships r ON r.object_id=p.ID
 INNER JOIN wp_term_taxonomy t ON t.term_taxonomy_id = r.term_taxonomy_id
 INNER JOIN wp_terms wt on wt.term_id = t.term_id
WHERE p.ID= {$id} AND t.taxonomy='category'";
        return $this->db->getQueryResultArray($sql);
        
    }
    
    public function getAllTags()
    {
        $sql = "SELECT * From wp_terms wt
INNER JOIN wp_term_taxonomy wtt ON wt.term_id=wtt.term_id WHERE wtt.taxonomy='post_tag' ";

        
        return $this->db->getQueryResultArray($sql);
        
    }
    
    public function getAllPosts()
    {
        $sql = "    SELECT wp_posts.* 
    FROM wp_posts, wp_postmeta
    WHERE wp_posts.ID = wp_postmeta.post_id 
    AND wp_posts.post_type = 'post'
    ORDER BY wp_posts.id ASC LIMIT 0, 10";
        $sql = "SELECT wp_posts.* FROM wp_posts WHERE  wp_posts.post_type = 'post'  ORDER BY wp_posts.id ASC";
        return $this->db->getQueryResultArray($sql);
        
    }
    

    function parseAttributesFromTag($tag){
        //The Regex pattern will match all instances of attribute="value"
        $pattern = '/(\w+)=[\'"]([^\'"]*)/';
        $matches = array();
        preg_match_all($pattern,$tag,$matches,PREG_SET_ORDER);

        $result = [];
        foreach($matches as $match){
            $attrName = $match[1];

            //parse the string value into an integer if it's numeric,
            // leave it as a string if it's not numeric,
            $attrValue = is_numeric($match[2])? (int)$match[2]: trim($match[2]);

            $result[$attrName] = $attrValue; //add match to results
        }

        return $result;
    }    
    
    protected function getIntroImage($html)
    {
        $new_html = '';
        $result = array();
        preg_match_all('/<img[^>]+>/i',$html, $result);
        preg_match_all('#<img:((?:[a-z][a-z0-9_]*))\s(((?!</img:).)*)\/>#iUs', $html, $matches);        
        $match_count = ___c($matches[0]);
        $c = ___c($result);
        if ($c > 0)
        {
            $img = $result[0][0];
            //print_r($img);die;
            $img_attrs = $this->parseAttributesFromTag($img); // $this->parseAttributes($img);
            $new_html = str_replace($img, '', $html);
            $a_href = '<a href="'.$img_attrs['src'].'"></a>';
            //<a href="https://www.spaceclearing.com/blog/wp-content/uploads/2008/02/futon.jpg"></a>

            $new_html = trim(str_replace( $img, '', $html));
            $new_html = trim(str_replace( $a_href, '', $new_html));
            //<a href="https://www.spaceclearing.com/blog/wp-content/uploads/2008/02/futon.jpg"></a>
            return ['html' => $new_html, 'image' => $img, 'image_attributes' => $img_attrs];
            
        }
        return null;
    }


    /**
     * Separate HTML elements and comments from the text.
     *
     * @since 4.2.4
     *
     * @param string $input The text which has to be formatted.
     * @return array The formatted text.
     */
    function wp_html_split( $input ) {
            return preg_split( $this->get_html_split_regex(), $input, -1, PREG_SPLIT_DELIM_CAPTURE );
    }

    /**
     * Retrieve the regular expression for an HTML element.
     *
     * @since 4.4.0
     *
     * @return string The regular expression
     */
    function get_html_split_regex() {
            static $regex;

            if ( ! isset( $regex ) ) {
                    $comments =
                              '!'           // Start of comment, after the <.
                            . '(?:'         // Unroll the loop: Consume everything until --> is found.
                            .     '-(?!->)' // Dash not followed by end of comment.
                            .     '[^\-]*+' // Consume non-dashes.
                            . ')*+'         // Loop possessively.
                            . '(?:-->)?';   // End of comment. If not found, match all input.

                    $cdata =
                              '!\[CDATA\['  // Start of comment, after the <.
                            . '[^\]]*+'     // Consume non-].
                            . '(?:'         // Unroll the loop: Consume everything until ]]> is found.
                            .     '](?!]>)' // One ] not followed by end of comment.
                            .     '[^\]]*+' // Consume non-].
                            . ')*+'         // Loop possessively.
                            . '(?:]]>)?';   // End of comment. If not found, match all input.

                    $escaped =
                              '(?='           // Is the element escaped?
                            .    '!--'
                            . '|'
                            .    '!\[CDATA\['
                            . ')'
                            . '(?(?=!-)'      // If yes, which type?
                            .     $comments
                            . '|'
                            .     $cdata
                            . ')';

                    $regex =
                              '/('              // Capture the entire match.
                            .     '<'           // Find start of element.
                            .     '(?'          // Conditional expression follows.
                            .         $escaped  // Find end of escaped element.
                            .     '|'           // ... else ...
                            .         '[^>]*>?' // Find end of normal element.
                            .     ')'
                            . ')/';
            }

            return $regex;
    }

    /**
     * Replace characters or phrases within HTML elements only.
     *
     * @since 4.2.3
     *
     * @param string $haystack The text which has to be formatted.
     * @param array $replace_pairs In the form array('from' => 'to', ...).
     * @return string The formatted text.
     */
    function wp_replace_in_html_tags( $haystack, $replace_pairs ) {
            // Find all elements.
            $textarr = $this->wp_html_split( $haystack );
            $changed = false;

            // Optimize when searching for one item.
            if ( 1 === count( $replace_pairs ) ) {
                    // Extract $needle and $replace.
                    foreach ( $replace_pairs as $needle => $replace );

                    // Loop through delimiters (elements) only.
                    for ( $i = 1, $c = count( $textarr ); $i < $c; $i += 2 ) {
                            if ( false !== strpos( $textarr[$i], $needle ) ) {
                                    $textarr[$i] = str_replace( $needle, $replace, $textarr[$i] );
                                    $changed = true;
                            }
                    }
            } else {
                    // Extract all $needles.
                    $needles = array_keys( $replace_pairs );

                    // Loop through delimiters (elements) only.
                    for ( $i = 1, $c = count( $textarr ); $i < $c; $i += 2 ) {
                            foreach ( $needles as $needle ) {
                                    if ( false !== strpos( $textarr[$i], $needle ) ) {
                                            $textarr[$i] = strtr( $textarr[$i], $replace_pairs );
                                            $changed = true;
                                            // After one strtr() break out of the foreach loop and look at next element.
                                            break;
                                    }
                            }
                    }
            }

            if ( $changed ) {
                    $haystack = implode( $textarr );
            }

            return $haystack;
    }    
    /**
     * Replaces double line-breaks with paragraph elements.
     *
     * A group of regex replaces used to identify text formatted with newlines and
     * replace double line-breaks with HTML paragraph tags. The remaining line-breaks
     * after conversion become <<br />> tags, unless $br is set to '0' or 'false'.
     *
     * @since 0.71
     *
     * @param string $pee The text which has to be formatted.
     * @param bool   $br  Optional. If set, this will convert all remaining line-breaks
     *                    after paragraphing. Default true.
     * @return string Text which has been converted into correct paragraph tags.
     */
    function wpautop( $pee, $br = true ) {
            $pre_tags = array();

            if ( trim($pee) === '' )
                    return '';

            // Just to make things a little easier, pad the end.
            $pee = $pee . "\n";

            /*
             * Pre tags shouldn't be touched by autop.
             * Replace pre tags with placeholders and bring them back after autop.
             */
            if ( strpos($pee, '<pre') !== false ) {
                    $pee_parts = explode( '</pre>', $pee );
                    $last_pee = array_pop($pee_parts);
                    $pee = '';
                    $i = 0;

                    foreach ( $pee_parts as $pee_part ) {
                            $start = strpos($pee_part, '<pre');

                            // Malformed html?
                            if ( $start === false ) {
                                    $pee .= $pee_part;
                                    continue;
                            }

                            $name = "<pre wp-pre-tag-$i></pre>";
                            $pre_tags[$name] = substr( $pee_part, $start ) . '</pre>';

                            $pee .= substr( $pee_part, 0, $start ) . $name;
                            $i++;
                    }

                    $pee .= $last_pee;
            }
            // Change multiple <br>s into two line breaks, which will turn into paragraphs.
            $pee = preg_replace('|<br\s*/?>\s*<br\s*/?>|', "\n\n", $pee);

            $allblocks = '(?:table|thead|tfoot|caption|col|colgroup|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|form|map|area|blockquote|address|math|style|p|h[1-6]|hr|fieldset|legend|section|article|aside|hgroup|header|footer|nav|figure|figcaption|details|menu|summary)';

            // Add a double line break above block-level opening tags.
            $pee = preg_replace('!(<' . $allblocks . '[\s/>])!', "\n\n$1", $pee);

            // Add a double line break below block-level closing tags.
            $pee = preg_replace('!(</' . $allblocks . '>)!', "$1\n\n", $pee);

            // Standardize newline characters to "\n".
            $pee = str_replace(array("\r\n", "\r"), "\n", $pee);

            // Find newlines in all elements and add placeholders.
            $pee = $this->wp_replace_in_html_tags( $pee, array( "\n" => " <!-- wpnl --> " ) );
            
            //$zz  =str_replace( "\n"" <!-- wpnl --> " ) ;
            // Collapse line breaks before and after <option> elements so they don't get autop'd.
            if ( strpos( $pee, '<option' ) !== false ) {
                    $pee = preg_replace( '|\s*<option|', '<option', $pee );
                    $pee = preg_replace( '|</option>\s*|', '</option>', $pee );
            }

            /*
             * Collapse line breaks inside <object> elements, before <param> and <embed> elements
             * so they don't get autop'd.
             */
            if ( strpos( $pee, '</object>' ) !== false ) {
                    $pee = preg_replace( '|(<object[^>]*>)\s*|', '$1', $pee );
                    $pee = preg_replace( '|\s*</object>|', '</object>', $pee );
                    $pee = preg_replace( '%\s*(</?(?:param|embed)[^>]*>)\s*%', '$1', $pee );
            }

            /*
             * Collapse line breaks inside <audio> and <video> elements,
             * before and after <source> and <track> elements.
             */
            if ( strpos( $pee, '<source' ) !== false || strpos( $pee, '<track' ) !== false ) {
                    $pee = preg_replace( '%([<\[](?:audio|video)[^>\]]*[>\]])\s*%', '$1', $pee );
                    $pee = preg_replace( '%\s*([<\[]/(?:audio|video)[>\]])%', '$1', $pee );
                    $pee = preg_replace( '%\s*(<(?:source|track)[^>]*>)\s*%', '$1', $pee );
            }

            // Collapse line breaks before and after <figcaption> elements.
            if ( strpos( $pee, '<figcaption' ) !== false ) {
                    $pee = preg_replace( '|\s*(<figcaption[^>]*>)|', '$1', $pee );
                    $pee = preg_replace( '|</figcaption>\s*|', '</figcaption>', $pee );
            }

            // Remove more than two contiguous line breaks.
            $pee = preg_replace("/\n\n+/", "\n\n", $pee);

            // Split up the contents into an array of strings, separated by double line breaks.
            $pees = preg_split('/\n\s*\n/', $pee, -1, PREG_SPLIT_NO_EMPTY);

            // Reset $pee prior to rebuilding.
            $pee = '';

            // Rebuild the content as a string, wrapping every bit with a <p>.
            foreach ( $pees as $tinkle ) {
                    $pee .= '<p>' . trim($tinkle, "\n") . "</p>\n";
            }

            // Under certain strange conditions it could create a P of entirely whitespace.
            $pee = preg_replace('|<p>\s*</p>|', '', $pee);

            // Add a closing <p> inside <div>, <address>, or <form> tag if missing.
            $pee = preg_replace('!<p>([^<]+)</(div|address|form)>!', "<p>$1</p></$2>", $pee);

            // If an opening or closing block element tag is wrapped in a <p>, unwrap it.
            $pee = preg_replace('!<p>\s*(</?' . $allblocks . '[^>]*>)\s*</p>!', "$1", $pee);

            // In some cases <li> may get wrapped in <p>, fix them.
            $pee = preg_replace("|<p>(<li.+?)</p>|", "$1", $pee);

            // If a <blockquote> is wrapped with a <p>, move it inside the <blockquote>.
            $pee = preg_replace('|<p><blockquote([^>]*)>|i', "<blockquote$1><p>", $pee);
            $pee = str_replace('</blockquote></p>', '</p></blockquote>', $pee);

            // If an opening or closing block element tag is preceded by an opening <p> tag, remove it.
            $pee = preg_replace('!<p>\s*(</?' . $allblocks . '[^>]*>)!', "$1", $pee);

            // If an opening or closing block element tag is followed by a closing <p> tag, remove it.
            $pee = preg_replace('!(</?' . $allblocks . '[^>]*>)\s*</p>!', "$1", $pee);

            // Optionally insert line breaks.
            if ( $br ) {
                    // Replace newlines that shouldn't be touched with a placeholder.
                    //$pee = preg_replace_callback('/<(script|style).*?<\/\\1>/s', '_autop_newline_preservation_helper', $pee);

                    // Normalize <br>
                    $pee = str_replace( array( '<br>', '<br/>' ), '<br />', $pee );

                    // Replace any new line characters that aren't preceded by a <br /> with a <br />.
                    $pee = preg_replace('|(?<!<br />)\s*\n|', "<br />\n", $pee);

                    // Replace newline placeholders with newlines.
                    $pee = str_replace('<WPPreserveNewline />', "\n", $pee);
            }

            // If a <br /> tag is after an opening or closing block tag, remove it.
            $pee = preg_replace('!(</?' . $allblocks . '[^>]*>)\s*<br />!', "$1", $pee);

            // If a <br /> tag is before a subset of opening or closing block tags, remove it.
            $pee = preg_replace('!<br />(\s*</?(?:p|li|div|dl|dd|dt|th|pre|td|ul|ol)[^>]*>)!', '$1', $pee);
            $pee = preg_replace( "|\n</p>$|", '</p>', $pee );

            // Replace placeholder <pre> tags with their original content.
            if ( !empty($pre_tags) )
                    $pee = str_replace(array_keys($pre_tags), array_values($pre_tags), $pee);

            // Restore newlines in all elements.
            if ( false !== strpos( $pee, '<!-- wpnl -->' ) ) {
                    $pee = str_replace( array( ' <!-- wpnl --> ', '<!-- wpnl -->' ), "\n", $pee );
            }

            return $pee;
    }    
    
    
    /**
     * Create thumbnail for uploaded images
     * @param array $datavalues
     * @param string $file_upload_var_name
     * @param string $datavalues_key
     * @return string
     */
    protected function createThumbnailForImageUpload($img_url, $dir, $filename_summary_intro_image)
    {
        if (empty($filename_summary_intro_image))
            return;
        $blog_app = new \App\Blog();
        $int_small_width = $blog_app->getConfig('int_small_width',128);
        $int_small_height = $blog_app->getConfig('int_small_height',128);
        $int_medium_width = $blog_app->getConfig('int_medium_width',512);
        $int_medium_height = $blog_app->getConfig('int_medium_height',512);        
        $int_large_width = $blog_app->getConfig('int_large_width',1920);
        $int_large_height = $blog_app->getConfig('int_large_height',1920);
        $int_image_quality = $blog_app->getConfig('int_image_quality',90);
            
        
        $new_image_filename =  $dir.'/'.pathinfo($filename_summary_intro_image, PATHINFO_FILENAME) . '.' . pathinfo($filename_summary_intro_image, PATHINFO_EXTENSION);
        //
        // name the image the same as the vfname
        $img_original_filename = $blog_app->getDataFileFullPath('image_original', $new_image_filename);
        //echo $img_original_filename;die;
        create_directory_if_not_exists(pathinfo($img_original_filename, PATHINFO_DIRNAME), true);

        //$valid_image = is_valid_uploaded_image_file($file_summary_intro_image['tmp_name'], $img_original_filename);
        if (!file_exists($img_original_filename))
        {
            try 
            {
                $imgdata = get_remote_file_content($img_url);
            }
            catch  (\Exception $exc)
            {
                $blog_app->recordLog("Cannot download {$img_url}");
                $saved = false;
            }
            $saved = file_put_contents($img_original_filename, $imgdata);
        } else $saved = true;
        if ($saved)
        {
        //$valid_image = is_valid_ ($file_summary_intro_image['tmp_name'], $img_original_filename);

            $img_small_filename = $blog_app->getDataFileFullPath('image_small', $new_image_filename);
            $img_medium_filename = $blog_app->getDataFileFullPath('image_medium', $new_image_filename);
            $img_large_filename = $blog_app->getDataFileFullPath('image_large', $new_image_filename);
            create_directory_if_not_exists(pathinfo($img_small_filename, PATHINFO_DIRNAME), true);
            create_directory_if_not_exists(pathinfo($img_medium_filename, PATHINFO_DIRNAME), true);
            create_directory_if_not_exists(pathinfo($img_large_filename, PATHINFO_DIRNAME), true);
            $result = create_image_thumbnail($img_original_filename, $img_small_filename, $int_small_width, $int_small_height);
            if (!$result)
                $blog_app->recordLog("Error while trying to create small thumbnail for: {$img_small_filename}");
            $result = create_image_thumbnail($img_original_filename, $img_medium_filename, $int_medium_width, $int_medium_height, false, $int_image_quality);
            if (!$result)
                $blog_app->recordLog("Error while trying to create medium image for: {$img_medium_filename}");
            $result = create_image_thumbnail($img_original_filename, $img_large_filename, $int_large_width, $int_large_height, false, $int_image_quality);
            if (!$result)
                $blog_app->recordLog("Error while trying to create large image for: {$img_large_filename}");
        } else
        {
            $blog_app->recordLog("Unable to save {$img_original_filename}");
            //throw new \Exception ("Unable to save {$img_original_filename}");
        }
        //return $datavalues;
    }    
    /**
     * 
     * @global \SCHLIX\cmsDatabase $SystemDB
     * @return array
     */
    public function ajaxPerformImport()
    {
        global $SystemDB;
        
        set_time_limit(60 * 15); // 15 minutes
        $this->db = new \SCHLIX\cmsDatabase($_SESSION['wp_dbhost'], $_SESSION['wp_dbname'] , $_SESSION['wp_dbusername'] , $_SESSION['wp_dbpassword'] );
                
        $blog = new \App\Blog();
        $SystemDB->query("TRUNCATE TABLE gk_blog_categories");
        $SystemDB->query("TRUNCATE TABLE gk_blog_categories_items");
        $SystemDB->query("TRUNCATE TABLE gk_blog_items");
        $allcategories = $this->getAllWPCategories();
        //$arr_match_id = [];
        foreach ($allcategories as $cat)
        {
            $existing_cat = $blog->getCategoryByID($cat['term_id']);
            if (!$existing_cat)
            {
                $datavalues = ['cid' => $cat['term_id'],'title' => $cat['name'], 'virtual_filename' => convert_to_safe_filename($cat['slug']), 'status' => 1,
                    'guid' => new_uuid_v4(),'date_created' => get_current_datetime(), 'options' => 'a:13:{i:0;s:27:"display_summary_intro_image";i:1;s:17:"display_pagetitle";i:2;s:27:"display_summary_intro_image";i:3;s:24:"display_child_categories";i:4;s:27:"display_summary_intro_image";i:5;s:34:"display_summary_secondary_headline";i:6;s:13:"display_items";i:7;s:25:"display_item_date_created";s:23:"child_categories_sortby";s:5:"title";s:30:"child_categories_sortdirection";s:3:"asc";s:12:"items_sortby";s:12:"date_created";s:19:"items_sortdirection";s:4:"desc";s:18:"image_display_size";s:12:"image_medium";}', 'meta_description' => $cat['name'],'permission_read' => 's:8:"everyone";', 'items_per_page' => 10];
            }
            /*$retval = $blog->saveCategory('new', $datavalues);
            if ($retval['id'] > 0)
            {
                //$SystemDB->query("UPDATE gk_blog_categories SET cid = {$cat['term_id']} WHERE cid = {$retval['id']}");
                $arr_match_id[] = ['old' => $cat['term_id'], 'new' => $retval['id']];
            }*/
            $blog->getCategoryTable()->quickInsert($datavalues);
            
        }
        
        $res = $blog->getAllCategories();
        $alltags = $this->getAllTags();
        /* category
link_category
nav_menu
post_tag
yst_prominent_words
*/
        /*
            [object_id] => 10910
            [term_taxonomy_id] => 784
            [term_order] => 0
            [term_id] => 784
            [taxonomy] => category
            [description] => 
            [parent] => 0
            [count] => 2
            [name] => maximum of $150 aud
            [slug] => maximum-of-150-aud
            [term_group] => 0*/
        $posts = $this->getAllPosts();
        $blog_app = new \App\Blog();
        foreach ($posts as $p)
        {
            //echo $p['post_content'];die;
            $id = $p['ID'];
            $pm = $this-> getPostMetaByID($id);
            $postcats = $this->getPostCategories($id);
            //print_r($postcats);die;
            $item_cats = [];
            foreach ($postcats as $pc)
            {
                $item_cats[] = $pc['term_id'];
            }
            $status = $p['post_status'] == 'publish' ? 1 : 0;
            
            
            $post_content = $this->wpautop($p['post_content']);
            $post_content = str_replace('<p></p>','', $post_content);
            $introimg = $this->getIntroImage($post_content);

            $datavalues = [
                'id' => $id,
                'title' => $p['post_title'],
                'virtual_filename' => convert_to_safe_filename( $p['post_name']),
                'guid' => new_uuid_v4(),
                'date_created' => $p['post_modified'],
                'status' => $status,
                'summary' => $post_content, //$p['post_content'],
                '__category_ids' => $item_cats,
                'primary_cid' => $item_cats[0]
                
                ];
            if ($introimg)
            {
                $attrs = $introimg['image_attributes'];
                $img_src = $introimg['image_attributes']['src'];
                $url = parse_url($img_src);
                $path = $url['path'];
                $pi = pathinfo($path);
                $dir = $pi['dirname'];
                $fn = $pi['basename'];
                $wpu = '/wp-content/uploads';
                $ln = strlen($wpu);
                $sp =  strpos($dir, $wpu);
                $year_month = substr ($dir, $sp + $ln +1, 7);
                
                
                $img_src_basename = basename($img_src);                
                $full_fn =  $year_month.'/'.$img_src_basename;
                
                $this->createThumbnailForImageUpload($img_src, $year_month, $img_src_basename);
                $datavalues['summary_intro_image'] = $full_fn ;
                $datavalues['summary_intro_image_caption'] = $attrs['alt'];
                $datavalues['summary'] = $introimg['html'];
            } 
            $blog->getItemTable()->quickInsert($datavalues);
            $insert_id =  $SystemDB->getLastInsertID();
            $blog->setItemCategories($insert_id, $item_cats);
            //$retval =  $blog->saveItem('new', $datavalues);
            
            /*if ($retval['id'] > 0)
            {
                $SystemDB->query("UPDATE gk_blog_items SET id = {$id} WHERE id = {$retval['id']}");
                $SystemDB->query("UPDATE gk_blog_categories_items SET id = {$id} WHERE id = {$retval['id']}");
            }*/
            
            
        }
        
        /* 	
_edit_last
_edit_lock
_paypal_access
_jetpack_dont_email_post_to_subs
_paypal_account_type
_yoast_wpseo_primary_category
_yoast_wpseo_content_score
_yst_prominent_words_version
_yoast_wpseo_focuskw_text_input
_yoast_wpseo_focuskw
_yoast_wpseo_title
_yoast_wpseo_metadesc
_yoast_wpseo_linkdex
_yoast_wpseo_focuskeywords
_jetpack_related_posts_cache*/
        
        
/*    AND wp_postmeta.meta_key = 'tag' 
    AND wp_postmeta.meta_value = 'email' 
    AND wp_posts.post_status = 'publish' 
*/        
        //print_r($posts);
        
        /*SELECT *
FROM wp_posts
LEFT JOIN wp_term_relationships ON (wp_posts.ID = wp_term_relationships.object_id)
LEFT JOIN wp_term_taxonomy ON (wp_term_relationships.term_taxonomy_id = wp_term_taxonomy.term_taxonomy_id)
WHERE 1
#AND wp_term_taxonomy.taxonomy = 'category'
AND wp_term_taxonomy.term_id IN (13)
#AND wp_term_taxonomy.term_id IN (1,2,3,4,5,6,7)
GROUP BY wp_posts.ID
ORDER BY ID*/
        
        
        return ajax_reply(200,'OK');
    }
    
    //_________________________________________________________________________//
    public function Run() {
        switch (fget_alphanumeric('action')) {
            case 'testdatabase': 
                return ajax_echo($this->ajaxGetDatabaseTestResult());
                break;
            case 'import': 
                return ajax_echo($this->ajaxPerformImport());
                break;
            default:return parent::Run();
        }
    }
    

}
            