/**
 *  - Javascript admin controller class
 *
 * @copyright 2018 SCHLIX Web Inc
 *
 * @license GNU GPLv3
 *
 * @package wpimporter
 * @version 1.0
 * @author  SCHLIX Web Inc <info@schlix.com>
 * @link    http://www.schlix.com
 */
SCHLIX.CMS.WPImporterAdminController = class extends SCHLIX.CMS.BaseController  {  
    /**
     * Constructor
     */
    constructor ()
    {
        super("wpimporter");
    };

    onDOMReady (event)
    {
        SCHLIX.Event.on('btn_test_database', 'click', this.onTestDBClick, this, true);
        SCHLIX.Event.on('btn_perform_import', 'click', this.onBtnPerformImportClick, this, true);
         SCHLIX.Dom.get('btn_perform_import').style.display = 'none';
    };
    
    onImportSuccess(o)
    {
        var response = ajax_parse(o.responseText);
        SCHLIX.Alert.info('OK');
        console.log(response);
        setApplicationBusyState(false);
    };
    
    
    onImportFailure(o)
    {
         db_test_result = '0';
         setApplicationBusyState(false);
    }; // end func
    
    onBtnPerformImportClick(e)
    {
        
        var postData = "_csrftoken=" + _csrftoken ;
        //this.ajaxRequestPOST(this.reportPOSTOperation, this.getUpdateFieldURL(), postData, 'cronscheduler');   
        setApplicationBusyState(true);

        var request = SCHLIX.Ajax.POST( site_httpbase + "/admin/app/" + this.app_name + "?action=import",
                {success: this.onImportSuccess, failure: this.onImportFailure, scope: this}, postData
                );
        
    };
    
    
    onGetTestDBResult(o)
    {
        var response = ajax_parse(o.responseText);
        var db_test_result = SCHLIX.Dom.get('db_tested');
        if (response != false)
        {
            SCHLIX.Alert.info(response);
            db_test_result.value = 'yes';
            SCHLIX.Dom.get('btn_perform_import').style.display = 'inline-block';
        } else
        {
            db_test_result = '0';            
        }
    };
    onFailedDatabaseTest(o)
    {
         db_test_result = '0';
    }; // end func
    onTestDBClick(event)
    {
        var db_username = SCHLIX.Dom.get('db_username').value;
        var db_password = SCHLIX.Dom.get('db_password').value;
        var db_host = SCHLIX.Dom.get('db_host').value;
        var db_database = SCHLIX.Dom.get('db_database').value;
        
        var postData = "_csrftoken=" + _csrftoken + '&username=' +db_username + '&password=' +db_password+ '&host=' + db_host+ '&database=' + db_database  ;
        //this.ajaxRequestPOST(this.reportPOSTOperation, this.getUpdateFieldURL(), postData, 'cronscheduler');   


        var request = SCHLIX.Ajax.POST( site_httpbase + "/admin/app/" + this.app_name + "?action=testdatabase",
                {success: this.onGetTestDBResult, failure: this.onFailedDatabaseTest, scope: this}, postData
                );
    }; // end func
    
    runCommand (command, evt)
    {
        switch (command)
        {
            case 'config':
                this.redirectToCMSCommand("editconfig");
                return true;
                break;
            
            default:
                return super.runCommand(command, evt);
                break;
        }
    }
};


